// 2021 to test seccomp jail
//to build: cd src; make && ../dbg/elf

#include<stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h> //syscall

#include <sys/syscall.h> //SYS_readv
#include <seccomp.h>
#include <linux/seccomp.h>


void block_syscall(int call)
{
	printf("will block syscall %d", call);
	scmp_filter_ctx ctx;
	ctx = seccomp_init(SCMP_ACT_ALLOW);
	seccomp_rule_add(ctx, SCMP_ACT_KILL, call, 0);
	seccomp_load(ctx);
}

void PopShell()
{
	const char * msg = "PopShell, 2021.02.04\n";
	const char * shellMsg = "will syscall SYS_execve shell\n";
	const char * filename = "/bin/sh";
	printf("SYS_write = %d, SYS_execve = %d\n", SYS_write, SYS_execve); //SYS_readv = 19 1 59
	printf("%s", msg);
	const char * argv[] = {filename, NULL};
	char * envp[] = {NULL};
	write(1, shellMsg, strlen(shellMsg));
	syscall(SYS_execve, filename, argv, envp);
}

void KernelVsLibc()
{
	const char * sLibc = "printed by libc write()\n";
	const char * sKernel = "printed by kernel\n";
	write(SYS_write, sLibc, strlen(sLibc));
	syscall(SYS_write, 1, sKernel, strlen(sKernel));
}

int main(int argc, char** argv)
{
	block_syscall(SCMP_SYS(execve));
	// block_syscall(SCMP_SYS(write)); // no output is printed except "Bad system call", as expected.
	KernelVsLibc();
	PopShell(); //causes "Bad system call"
	printf("this msg won't show up if seccomp stopped previous syscalls");  
}


/* /usr/include
./x86_64-linux-gnu/bits/syscall.h:# define SYS_execve __NR_execve define SYS_readv __NR_readv
//#include "head.h"
//#include <sys/types.h>
//#include <signal.h>
#include <typeinfo> //typeid

*/